

import java.util.Stack;

/*
 * Created on Mar 17, 2005
*/

/**
 * @author popel
 */

// SINGLETON CLASS

public class ClientList {
	private ClientInfo cList [] = new ClientInfo[Server.MAX_CONNECTION];
	private int totalElem = 0;
	public static ClientList onlyList = new ClientList();
	
	private Stack userNumber = new Stack(); 
	public ClientList getInstance()
	{
		return onlyList;
	}
	private ClientList()
	{
		// private constructor
		for(int i=100;i>=1;i--)
			
				userNumber.push(new Integer(i));
				
	}
	public synchronized void newClientAuthorized(int cn,String un,String ip)
	{
		
		cList[cn] =  new ClientInfo(cn,un,ip);
		
		// save the position where the client is saved in the vector
		//ht.put(new Integer(cn),new Integer(totalElem));
		totalElem++;
	}
	public synchronized void deleteClient(int cn)
	{
		// find the client with number "cn" and delete him from the list
		
		cList[cn] = null;
		// the elements will automatically ahead one step
		reuseUserNumber(cn);
		totalElem--;
		
	}
	public synchronized int getTotalAuthorizedClients()
	{
		return totalElem; 
	}
	public synchronized ClientInfo getClientAt(int i)
	{
		return ((ClientInfo)cList[i]);
	}
	public int getNextUserNumber()
	{
		
		int i = ((Integer)userNumber.pop()).intValue();
		System.out.println(Integer.toString(i)+ " supply");
		return i;
	}
	public void reuseUserNumber(int num)
	{
		userNumber.push(new Integer(num));
		System.out.println(Integer.toString(num)+ " number returned");
		
	}
	
	
	
}