
import javax.media.protocol.*;
import javax.media.rtp.*;
import javax.media.rtp.rtcp.*;

import java.net.*;


public class RTPTransmitter {
	String ipAddress;
	DataSource dataOutput;
	int portBase;
	private RTPManager rtpMgrs[];
	public int portArray[] = new int[10]; // media tracks
	public RTPTransmitter(String ip,int port,DataSource ds)
	{
		dataOutput = ds;
		ipAddress = ip;
		//ipAddress = "239.0.0.1";
		portBase = port;
		
			
	}
	/**
     * Use the RTPManager API to create sessions for each media 
     * track of the processor.
     */
    public String start() {

	// Cheated.  Should have checked the type.
	
    PushBufferDataSource pbds = (PushBufferDataSource)dataOutput;
	PushBufferStream pbss[] = pbds.getStreams();

	
	rtpMgrs = new RTPManager[pbss.length];
	SendStream sendStream;
	int port;
	SourceDescription srcDesList[];

	for (int i = 0; i < pbss.length; i++) {
	    try {
		rtpMgrs[i] = RTPManager.newInstance();	    

		port = portBase + 2*i;
		portArray[i] = port;
		// Initialize the RTPManager with the RTPSocketAdapter
		rtpMgrs[i].initialize(new RTPSocketAdapter(
					InetAddress.getByName(ipAddress), 
					port));

		System.err.println( "Created RTP session: " + ipAddress + " " + port);
		
		sendStream = rtpMgrs[i].createSendStream(dataOutput, i);		
		sendStream.start();
		
		
	    } catch (Exception  e) {
		return e.getMessage();
	    }
	}

	return null;
    }
    
	public void stop()
		{
			for (int i = 0; i < rtpMgrs.length; i++) {
			    rtpMgrs[i].removeTargets( "Session ended.");
			    rtpMgrs[i].dispose();
			}
			
		}
		

	
}



